
; ---------------------------------------------------------------------------
; TestBed.asm
; ---------------------------------------------------------------------
; Author: frktons @ MASM32 forum
; Date: 13/nov/2010. 
;---------------------------------------------------------------------- 
; Enjoy - Frank
;----------------------------------------------------------------------------

include \masm32\include\masm32rt.inc

.686
.mmx
.xmm

include \masm32\macros\timers.asm
			
; get them from the 
; [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]


include ProgData.inc

ALGO_ALL_IS_OK			EQU 0
ALGO_IS_NOT_IMPLEMENTED		EQU 1
ALGO_IS_NOT_SUPPORTED		EQU 2

ALGO_REQUIRE_i486		EQU 0
ALGO_REQUIRE_MMX		EQU 1
ALGO_REQUIRE_SSE1		EQU 2
ALGO_REQUIRE_SSE2		EQU 3
ALGO_REQUIRE_SSE3		EQU 4
ALGO_REQUIRE_SSSE3		EQU 5
ALGO_REQUIRE_SSE41		EQU 6
ALGO_REQUIRE_SSE42		EQU 7

NUMBER_OF_ALGO_FILES EQU 16

; include 16 algos files
_COUNTER=1
WHILE _COUNTER LT NUMBER_OF_ALGO_FILES+1
@CatStr(<include algo>,%_COUNTER,<.inc>)
_COUNTER=_COUNTER+1
ENDM


.data
	align 4
	AlgosDescriptionTable	label	dword
		_COUNTER=1
		WHILE _COUNTER LT NUMBER_OF_ALGO_FILES+1
		@CatStr(<dd offset Algo>,%_COUNTER,<_Description>)
		_COUNTER=_COUNTER+1
		ENDM
		
	AlgosPtrTable	label	dword
		_COUNTER=1
		WHILE _COUNTER LT NUMBER_OF_ALGO_FILES+1
		@CatStr(<dd offset Algo>,%_COUNTER,<_Run>)
		_COUNTER=_COUNTER+1
		ENDM
		
	AlgosSizeTable	label	dword
		_COUNTER=1
		WHILE _COUNTER LT NUMBER_OF_ALGO_FILES+1
		@CatStr(<Algo>,%_COUNTER,<_Size dd algo>,%_COUNTER,<_end-algo>,%_COUNTER,<_start>)
		_COUNTER=_COUNTER+1
		ENDM
		
.data?
	dwMaxInstructionsSupported	dd	?

.code

start: 

; ---------------------------------------------------------------------------
; The Main Proc shows the program flow.
; ---------------------------------------------------------------------------

Main PROC

    mov RowInitialFile, One    
    mov RowFinalFile,   MaxRows    
    mov ColInitialFile, One   
    mov ColFinalFile,   MaxCols  

;----------------------------------------------------------------------------------------------------
; Initialize structure for calling GetNumberFormat
;----------------------------------------------------------------------------------------------------

mov NumFmt.NumDigits, 0               ; 0 for No decimal digits
mov NumFmt.LeadingZero, 0             ; 0 = No leading zeroes
mov NumFmt.Grouping, 3                ; Groups of three numbers
mov NumFmt.lpDecimalSep,  offset Sep  ; Pointer to NULL terminated string with the decimal separator 
mov NumFmt.lpThousandSep, offset Tsep ; Pointer to NULL terminated string with the thousand separator
mov NumFmt.NegativeOrder, 0           ; Negative number mode OFF

;----------------------------------------------------------------------------------------------------

    mov    DisplayFlag, NO
    
    CALL   ConsoleSize 

    CALL   GetConsole

    CALL   InitProc

    mov    PtrTextString, offset  TextString

    mov    PtrTextString, add$(PtrTextString, "TESTHELP.POP") 

    INVOKE ReadChosenFile, DWORD PTR PtrTextString, ADDR HelpBuffer

    INVOKE AlexConvertArea, ADDR HelpScreen, ADDR HelpBuffer, NumCycles

    INVOKE AlexConvertArea, ADDR ConsoleScreen16, ADDR FileBuffer, NumCycles

    INVOKE DisplayFmt,   offset ConsoleScreen16

    INVOKE SaveArea, offset TestAreaBuffer, TestAreaRowInit, TestAreaColInit, 
                     TestAreaRowEnd, TestAreaColEnd
                      
    
    mov    ActualColor,  Zero
    
    INVOKE GetWindowsOS, ADDR szOS
    
    INVOKE lstrcat, ADDR szOS, CTEXT(13,10); Eliminate duplicate spaces

    INVOKE SetColorTo, BrightYellow, DarkBlue

    mov    Lenght, len(ADDR szOS)
   
    INVOKE DisplayAt, 7, 1, ADDR szOS, DWORD PTR Lenght

; ###########################################################################
; # This code is addeded by Alex 
; ###########################################################################
      
    invoke AxCPUid, offset CpuBuffer
    
    ; -----------------------------------------------------------------------
    ; NOTE: After a call to ^^^ this proc, the EAX is constructed, read
    ; comments above proc
    ; -----------------------------------------------------------------------
        
    ; maximal instruction sets, supported by CPU
    mov word ptr dwMaxInstructionsSupported,ax
 

    ; -------------------------------------------------------------------------------
    ; for example, if test include code, which is required SSSE3, then need to check
    ; an AX (or EBX in this sample) for 5. If number is smaller than 5, then SSSE3 
    ; is not supported and needed to manage that thing.
    ; -------------------------------------------------------------------------------
    
; ###########################################################################
;  Code replaced by Alex - he likes it popped and pushed :-) / I don't. ;-)
; ###########################################################################

    lea    esi, CpuBuffer

    mov    pbuf, esi

    invoke szMonoSpace, esi                ; format it with single space

    mov    Lenght, len(ADDR CpuBuffer)

TestDisplay:


    INVOKE SetColorTo, BrightWhite, DarkBlue

    INVOKE DisplayAt, ColCpuDesc, RowCpuDesc1, ADDR CpuBuffer, DWORD PTR Lenght   


; ###########################################################################


    INVOKE SetColorTo, BrightYellow, DarkBlue
    
    StartAlgo1:
    mov edi,4
    mov esi,4
    xor ebx,ebx
    push eax
    @@theManager:

    inc ebx
    cmp ebx,NUMBER_OF_ALGO_FILES
    ja @@doneManager
    mov edi,36
    add esi,2
    
    ; print description of the algo
    mov ecx,[AlgosDescriptionTable+ebx*4-4]
    push eax
    push ecx
    push esi
    push 4
    
    invoke lstrlen,ecx
    mov [esp+12],eax
    call DisplayAt
    
    ; print the tests
    
    xor ebp,ebp
    
    push [AlgosSizeTable+ebx*4-4]
    push offset fmtu
    push offset AlgoTicksStr
    call wsprintf
    add esp,12
    
    invoke DisplayAt,38,esi,offset AlgoTicksStr,eax
    
    @@printclocks:    
    push esp
    call dword ptr [AlgosPtrTable+ebx*4-4]
    
    .data
    align 4
    whatIsWithAlgo	dd	offset	@@supported
    			dd	offset	@@theManager
    			dd	offset	@@notsupported
    			dd	offset	@@badboy
    even
    notsupported	db	"N/A",0    		
    even
    badboy		db	"Bad Boy",0
    even
    fmtu		db	"%u",0
    .code
    
    and eax,3
    jmp dword ptr [eax*4+whatIsWithAlgo]
    
    @@notsupported:
    mov ecx,offset notsupported
    mov eax,sizeof notsupported-1
    jmp @F
    
    @@badboy:
    mov ecx,offset badboy
    mov eax,sizeof badboy-1    
    jmp @F

    @@supported:
    push offset fmtu
    push offset AlgoTicksStr
    call wsprintf
    
    ; if you like "strange fancy methods", you can put zero instead of "1"
    ; here :P
    if 1
    
    add esp,8
    
    invoke FormatNum,offset AlgoTicksStr
    
    else
    
    call FormatNum
    pop edx
    
    endif
    
    mov ecx,offset BufNum
    @@:
    add edi,11
    INVOKE DisplayAt, edi, esi, ecx,eax
    
    inc ebp
    cmp ebp,4
    jb @@printclocks
    
    jmp @@theManager
    @@doneManager:
    
    pop edx
   
        
; ###########################################################################

; ---------------------------------------------------------------------------
; jump here to terminate the  sequence of Algo tests.
; If 16 Algos are tested the program flow will arrive here.
; ---------------------------------------------------------------------------

EndOfTests:

    mov    ConfirmExit, NO

    INVOKE SaveScreen, offset SavedScreen

    mov RunAgain, NO

      
    CALL   AnyKey

    .IF  ( ConfirmExit == YES )

        jmp Finish

    .ENDIF

    .IF  ( RunAgain == YES )

        jmp StartAlgo1

    .ENDIF


Finish: 


    CALL   ShowTheCursor

    INVOKE SetColorTo, BrightWhite, DarkBlack

    CALL   ClearScreen

    exit

Main ENDP


include ProgPROC.inc

;----------------------------------------------------------------------------
; End of program
;----------------------------------------------------------------------------

end start